#LogTo("basic.log");;

#Preliminaries

#We introduce our generic parameter q

q:=Indeterminate(Rationals,"q");


#We denote by "K" the field of rational functions on those two variables. 

K:=Field(q);;

#"F1" (also, later F(1)) and "F0" will denote the unit and the null element of the field "K"
F1:=One(K);;
F0:=Zero(K);;

u:=-F1;;
#we define our roots in the field K, they shall be called "F()" instead of E():

F:=n->E(n)*F1;



R:=function(n)
local l,k;
l:=[];
for k in [1..n] do
if Order(F(n)^k)=n then
Add(l,F(n)^k);
fi;
od;
return l;
end;

#We collect in "C(n)" the Zet of roots of order leeser or equal than n
C:=function(n)
local l,k;
l:=[];
for k in [1..n] do
if F(n)^k<>F1 then
Add(l,F(n)^k);
fi;
od;
return l;
end;

#We introduce a function to eliminate duplicates, which works in our particular Zetting better than the built-in function "Zet".


Zet:=function(l)
local d,f;
f:=[];
for d in l do
if d in f then
else
Add(f,d);
fi;
od;
return f;
end;

#The Set of roots we need to check.


Gf:=Zet(Concatenation(C(10),C(12),C(18)));;


# To calculate m(i,j)



mv:=function(v,w)
local l,n;
l:=[];
for n in [0..3] do
	if v^n*w=F1 then Add(l,n);
	fi;
od;
if Number(l)=0 then return
Order(v)-1;
else return
Minimum(l);
fi;
end;


###### end Preliminaries.


